(in-package #:odo/model-api)

(defsection @odo/model-api/transition-constraint (:title "Transition constraints")
  "Transition constraints relate the values of variables and state variables at
two sequential points in time. It responds to the same functions as a
constraint, except the return value of `constraint-expression` is an Odo
expression that can refer to `+CURRENT-TIME+` and `+PREVIOUS-TIME+`."
  (odo:transition-constraint class)
  (odo:odo-transition-constraint class)
  (odo:transition-constraint-p generic-function)
  (odo:odo-transition-constraint-p generic-function)
  (odo:make-transition-constraint function))


;;; Types

(defclass odo:transition-constraint (odo:object)
  ()
  (:documentation
   "A transition constraint."))

(utils:define-renamed-class odo:odo-transition-constraint odo:transition-constraint)

(defgeneric odo:transition-constraint-p (obj)
  (:documentation
   "Returns T iff `OBJ` is an Odo transition constraint.")
  (:method ((obj t))
    nil))

(utils:define-renamed-generic (odo:odo-transition-constraint-p odo:transition-constraint-p) (obj))


;;; Constructor

(defun odo:make-transition-constraint (predicate
                                       &key
                                         (name (gensym "TC"))
                                         annotations
                                       &allow-other-keys)
  "Instantiate and return a new transition constraint.

`PREDICATE` Must be an instance of an `ODO-EXPRESSION`, using `+CURRENT-TIME+`
and `+PREVIOUS-TIME+`.

If `NAME` is not supplied, a name is autogenerated."
  (assert (typep (odo:type predicate) 'odo:expression))
  (odo:make-instance 'odo:transition-constraint
                     :name name
                     :predicate predicate
                     :annotations annotations))


;;; API

(defmethod odo:equal-p-by-type (left right
                                (left-type odo:transition-constraint)
                                (right-type odo:transition-constraint))
  (and
   (eq left-type right-type)
   (equal (odo:name left)
          (odo:name right))
   (utils:plist-equal (odo:annotation-plist left)
                      (odo:annotation-plist right))
   (odo:equal-p (odo:expression left)
                (odo:expression right))))


(defmethod odo:copy-by-type (c (type odo:transition-constraint) &key context)
  (odo:make-transition-constraint (odo:copy (odo:expression c) :context context)
                                  :name (odo:name c)
                                  :annotations (copy-list (odo:annotation-plist c))))

(defmethod utils:print-odo-object-by-type (c (type odo:transition-constraint) stream)
  (utils:odo-print-unreadable-object (c stream)
    (write (class-name (class-of (odo:type c))) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:name c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:expression c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write :annotations :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:annotation-plist c) :stream stream)))
